aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorGlenn Washburn <development@efficientek.com>2022-08-11 12:06:43 -0500
committerDaniel Kiper <daniel.kiper@oracle.com>2022-08-19 21:57:46 +0200
commit995a745c2814bce942c42d082ffa670fbaf7596d (patch)
tree7b9207f22ffeecbc34e70dff53055a4ebdf9a722
parent69edb31205602c29293a8c6e67363bba2a4a1e66 (diff)
downloadgrub-995a745c2814bce942c42d082ffa670fbaf7596d.tar.gz
tests/util/grub-shell: Only show grub-mkrescue output if it returns an error
The previous behavior ignored an error and the output from grub-mkrescue. This made it difficult to discover that grub-mkrescue was the reason that tests which rely on grub-shell were failing. Even after discovering grub-mkrescue was the culprit, there was no output to indicate why it was failing. It turns out that grub-mkrescue is a thin wrapper around xorriso. So if you do not have xorriso installed it will fail with an error message about not being able to find xorriso. This change will allow grub-mkrescue output to be written to stderr, only if grub-mkrescue fails. If grub-mkrescue succeeds, there will be no output from grub-mkrescue so as not to interfere with the functioning of tests. This change should have no effect on the running of tests or other uses of grub-shell as it only modifies the error path. Also, if grub-mkrescue fails, the script exits early. Since grub-shell needs the ISO image created by grub-mkresue to boot the QEMU instance, a failure here should be considered fatal. Signed-off-by: Glenn Washburn <development@efficientek.com> Reviewed-by: Daniel Kiper <daniel.kiper@oracle.com>
-rw-r--r--tests/util/grub-shell.in17
1 files changed, 15 insertions, 2 deletions
diff --git a/tests/util/grub-shell.in b/tests/util/grub-shell.in
index bb7b285e9..ce431757c 100644
--- a/tests/util/grub-shell.in
+++ b/tests/util/grub-shell.in
@@ -59,6 +59,17 @@ Report bugs to <bug-grub@gnu.org>.
EOF
}
+# Exec given argv and only show its output on STDERR if it returns an
+# error status.
+exec_show_error () {
+ v=`$@ 2>&1`
+ ret=$?
+ if [ "$ret" != 0 ]; then
+ echo "$v" >&2
+ exit $ret
+ fi
+}
+
. "${builddir}/grub-core/modinfo.sh"
qemuopts="${GRUB_QEMU_OPTS}"
serial_port=com0
@@ -384,13 +395,15 @@ if test -z "$debug"; then
fi
if [ x$boot != xnet ] && [ x$boot != xemu ]; then
- pkgdatadir="${builddir}" "${builddir}/grub-mkrescue" "--output=${isofile}" "--override-directory=${builddir}/grub-core" \
+ pkgdatadir="${builddir}" \
+ exec_show_error "${builddir}/grub-mkrescue" "--output=${isofile}" \
+ "--override-directory=${builddir}/grub-core" \
--rom-directory="${rom_directory}" \
--locale-directory="${srcdir}/po" \
--themes-directory="${srcdir}/themes" \
$mkimage_extra_arg ${mkrescue_args} \
"/boot/grub/grub.cfg=${cfgfile}" "/boot/grub/testcase.cfg=${source}" \
- ${files} >/dev/null 2>&1
+ ${files} || exit $?
fi
if [ x$boot = xhd ]; then
if [ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = arm64-efi ] || [ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = arm-efi ]; then